package mdb;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

/**
 * @author Jan Martiska
 * bin/run.sh -c all -Dmdb.queue=queue/QueueForNew
 */
@MessageDriven(
        activationConfig = {
                /*@ActivationConfigProperty(propertyName = "destination", propertyValue="queue/QueueForNew"),*/
                @ActivationConfigProperty(propertyName = "destination", propertyValue="${mdb.queue}"),
                @ActivationConfigProperty(propertyName = "destinationType", propertyValue="javax.jms.Queue")
        }
)
public class NewMDB implements MessageListener{

    @Resource
    private MessageDrivenContext mdc;

    @Override
    public void onMessage(Message inMessage) {
        TextMessage msg = null;

        try {
            if (inMessage instanceof TextMessage) {
                msg = (TextMessage) inMessage;
                System.out.println("Message received in 'new' queue: " + msg.getText());
            } else {
                System.out.println("ERROR!");
            }
        } catch (JMSException e) {
            e.printStackTrace();
            mdc.setRollbackOnly();
        } catch (Throwable te) {
            te.printStackTrace();
        }
    }

}
